local mapMod = foundation.createMod();

-- registering map files
mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")

-- register custom map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MONT_SAINT-MICHEL_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -21,
	MaxHeight = 179,
	VillagePathList = {
		{
			Entrance = { 1022, 0, 448 },
			Exit = { 726, 0, 1 },
		},
		{
			Entrance = { 4, 0, 391 },
			Exit = { 446, 0, 1 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 580 , 19 , 872 },
			Orientation = { 0.0, 55.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 1 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 590 , 29 , 856 },
			Orientation = { 0.0, -125.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 2 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 645 , 16 , 896 },
			Orientation = { 0.0, -140.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 3 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 593 , 4 , 752 },
			Orientation = { 0.0, -70.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 4 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 626 , 34 , 810 },
			Orientation = { 0.0, 175.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 5 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 58 , 3 , 321 },
			Orientation = { 0.0, 60.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 6 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 566 , 38 , 842 },
			Orientation = { 0.0, -12.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 637 , 28 , 807 },
			Orientation = { 0.0, -105.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 8 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 566 , 24 , 818 },
			Orientation = { 0.0, -6.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 9 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 606 , 23 , 794 },
			Orientation = { 0.0, 115.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 10 => rocky island
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 584 , 29 , 802 },
			Orientation = { 0.0, -48.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 925 , -1 , 524 },
			Orientation = { 0.0, -75.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 12 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 965 , 5 , 38 },
			Orientation = { 0.0, -45.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 13 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_3", 
			Position = { 41 , 8 , 325 },
			Orientation = { 0.0, -18.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 14 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 85 , 6 , 303 },
			Orientation = { 0.0, 90.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 15 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 175 , 8 , 46 },
			Orientation = { 0.0, -10.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 16 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 186 , 7 , 38 },
			Orientation = { 0.0, 170.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 17 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 372 , 7 , 40 },
			Orientation = { 0.0, 180.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 18 => coast
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 949 , 6 , 41 },
			Orientation = { 0.0, -0.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 19 => small island
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 939 , 0 , 531 },
			Orientation = { 0.0, 90.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 20 => river island 
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 692 , -1 , 149 },
			Orientation = { 0.0, -80.0 , 0.0},
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.501953125,0.9999847412109375,0.501953125,1 },
							Max = { 0.4078369140625,0.556854248046875,0.0588226318359375,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
